var gui = require('nw.gui');
var win = gui.Window.get();

var body = document.body;
var view = document.getElementById('main');

const fs = require('fs');


var resetClasses = function () {
    $(body).removeClass('is-showing-spinner was-successful is-dragging has-error');
}

var updateStatus = function (message) {
    $(body).find('.status').html(message);
}

var toggleSpinner = function (state) {
    resetClasses();
    $(body).toggleClass('is-showing-spinner', state);
};

var toggleSuccess = function (state) {
    resetClasses();
    $(body).toggleClass('was-successful', state);
    console.log("sucess");
};

function unhideElement(element) {
    if ($(element).hasClass("hide")) {
        $(element).removeClass("hide");
    }
}
function hideElement(element) {
    if (!$(element).hasClass("hide")) {
        $(element).addClass("hide");
    }
}
function hideElementAnimated(element) {
    if (!$(element).hasClass("hideAnimated")) {
        $(element).addClass("hideAnimated");
    }
}

function unhideElementAnimated(element) {
    if ($(element).hasClass("hideAnimated")) {
        $(element).removeClass("hideAnimated");
    }
}


function showMessage(m) {
    $("#message").html(m);
    unhideElementAnimated("#message");
}

function showError(code) {
    var message = getErrorForCode(code) || 'Error: ' + code.toString();
    $("#error").html("Ugggh...<br>" + message);
    unhideElementAnimated("#error");
}

var messagesUninstall = ["Good luck out there!", "You're on your own.", "I could use a drink.", "We never wanted this.", 
    "You were right all along.","This doesn't change things.", "This cannot be good.",
    "This is not a good thing."];

function uninstallSuccess() {
    var ranMessage = messagesUninstall[Math.floor(Math.random() * messagesUninstall.length)];
    showMessage("Squall was uninstalled.<br>" + ranMessage);
}


function uninstall() {

    hideInstallPage();
    $("#uninstallButton").get(0).disabled = true;
    hideElementAnimated("#uninstallButton");
        $("#logo").removeClass("hideAnimated");
    $("#spinner").removeClass("hideAnimated");
    
    var dir = fs.realpathSync('.');
    console.log("start");
    var promise = uninstallExtension(dir);
    promise.then(function (result) {
           $("#spinner").addClass("hideAnimated");
        uninstallSuccess();
    }, function (err) {
           $("#spinner").addClass("hideAnimated");
        showError(err);
    });
}

var messages = ["Nice.", "But now what?",
    "On with your day!", "Good. Good."];



var install = function () {

    hideInstallPage();
    $("#logo").removeClass("hideAnimated");
    $("#spinner").removeClass("hideAnimated");

    $("#installButton").get(0).disabled = true;

    var dir = fs.realpathSync('.');

    var promise = installAtPath(getPathAndVersion()[0], dir);

    promise.then(function (result) {
        $("#spinner").addClass("hideAnimated");
        var ranMessage = messages[Math.floor(Math.random() * messages.length)];
        showMessage("Squall is installed.<br>" + ranMessage);
    }, function (err, code) {
        console.log("code", err);
        if (err == -418) {
            console.log(code);
            forceInstall();
        } else {
           $("#spinner").addClass("hideAnimated");
            showError(err);    
        }
    });

}

var forceInstall = function () {
    var dir = fs.realpathSync('.');
    var promise = uninstallExtension(dir);
    promise.then(function (result) {

        var promise2 = installAtPath(getPathAndVersion()[0], dir);
        promise2.then(function (result) {
            $("#spinner").addClass("hideAnimated");
            var ranMessage = messages[Math.floor(Math.random() * messages.length)];
            showMessage("Squall is installed.<br>" + ranMessage);
        }, function (err) {
            $("#spinner").addClass("hideAnimated");
            showError(err);
        });

    }, function (err) {
        showError(err);
    });
       
}

function agree() {
    $("#installButton").get(0).disabled = !$("#checkboxG3").is(":checked");
}

function getPathAndVersion() {
    var paths = fs.readdirSync(".");
    var returnArray = null;
    paths.forEach(function (element) {

        var r = new RegExp('squall-(.*).zxp', "g");
        var matches = r.exec(element);
        if (matches) {
            returnArray = ["squall-" + matches[1] + ".zxp", matches[1]];
        }

    }, this);
    return returnArray;
}


function hideInstallPage() {
    hideElement("#agree");
    hideElement("#licenseAgreement");
    hideElement("#installButton");
    hideElement("#uninstallButton");
}

function showInstallPage() {
    unhideElementAnimated("#licenseAgreement");
    unhideElementAnimated("#installButton");
    unhideElementAnimated("#agree");
}

function showUninstallPage(version) {

    $("#uninstallButton").html("Uninstall Squall AE Extension " + version.toString());
    $("#agree").addClass("hide");
    $("#licenseAgreement").addClass("hide");
    $("#installButton").addClass("hide");
    $("#logo").removeClass("hideAnimated");
    unhideElement("#uninstallButton");
    setTimeout(function () { unhideElementAnimated("#uninstallButton") }, 500);


}

function showUpdatePage(version) {
    unhideElement("#uninstallButton");
    $("#installButton").addClass("bigButton");
    $("#installButton").addClass("floatMe");
    $("#uninstallButton").addClass("floatMe");
    $("#uninstallButton").addClass("smallButton");
    
    $("#installButton").html("Update to Squall AE Extension " + version.toString());
    showInstallPage();
}

function determineLayout() {
    var dir = fs.realpathSync('.');
    var promise = checkInstalledVersion(dir);

    promise.then(function (result) {

        var installedVersion = parseFloat(result);
        var packageVersion = parseFloat(getPathAndVersion()[1]);

        if (installedVersion < packageVersion) {
            showUpdatePage(packageVersion);
        } else {
            showUninstallPage(installedVersion);
        }

    }, function (err) {
        showInstallPage();
        console.log(err);
    });
}

$(document).ready(function () {
    var path = getPathAndVersion();
     
     determineLayout();
    
    $("#installButton").html("Install Squall AE Extension " + path[1]);

    setTimeout(function () {
        win.show();
    }, 100);

});


